package registrojdbc;

import java.util.*;

class Datos {

  protected Atributo atributo;
  protected Vector<Atributo> listaAtributos;

  public Datos() {
    listaAtributos = new Vector<Atributo>();
  }
  protected void agregarAtributo(String nombre, String valor) {
    atributo = new Atributo(nombre,valor);
    listaAtributos.addElement(atributo);
  }
  protected void agregarAtributo(String nombre) {
    atributo = new Atributo(nombre,"");
    listaAtributos.addElement(atributo);
  }
  public int numeroAtributos() {
    return listaAtributos.size();
  }
  private void borrarTodos() {
     for (int i = 0; i < listaAtributos.size(); i++) {
          atributo = (Atributo) listaAtributos.elementAt(i);
          if (atributo != null)
            atributo.escribirValor("");
      }
  }
  public String leerNombre(int i) {
    String str = null;
    atributo = (Atributo) listaAtributos.elementAt(i);
    if (atributo != null)
        str = atributo.leerNombre();
    return str;
  }
  public int leerIndice(String str) {
    String nombre;
    for (int i = 0; i < listaAtributos.size(); i++){
          atributo = (Atributo) listaAtributos.elementAt(i);
          if (atributo != null && (nombre = atributo.leerNombre()) != null
                && nombre.equals(str) == true)
                  return i;
    }
    return -1;
  }
  public String leerValor(String nombre) {
      String str = null;
      int i = leerIndice(nombre);
      if (i != -1)
            str = leerValor(i);
      return str;
  }
  public String leerValor(int i) {
      String str = null;
      atributo = (Atributo) listaAtributos.elementAt(i);
      if (atributo != null)
            str = atributo.leerValor();
      return str;
  }
  public void escribirValor(int i,String str) {
      atributo = (Atributo) listaAtributos.elementAt(i);
      if (atributo != null)
            atributo.escribirValor(str);
  }
  public void printAll() {
     for (int i = 0; i < listaAtributos.size(); i++)
        if (atributo != null)
            atributo.print();
  }
  public String serializarSQL() {
    String serializa0 = "";
    for (int i = 0; i < listaAtributos.size(); i++) {
      if (i > 0)   {
        serializa0 = serializa0 + ", ";
      }
      serializa0 = serializa0 + leerNombre(i) + " = " +
        "'" + leerValor(i) + "'";
    }
    return serializa0;
  }
  public String serializarSQLinsert() {
         String serializa0 = "";
         String serializa1 = "";
         for (int i = 0; i < listaAtributos.size(); i++) {
                if (i > 0)   {
                  serializa0 = serializa0 + ", ";
                  serializa1 = serializa1 + ", ";
                }
                serializa0 = serializa0 + leerNombre(i);
                serializa1 = serializa1 + "'" + leerValor(i) + "'";
         }
         return "(" + serializa0 + ") VALUES (" + serializa1 + ")";
  }
}
