package registrojdbc;

public class ManejadorRegistroUsuario extends Manejador {
    
   private PantallaRegistroUsuario pantallaRegistroUsuario;
   private InterfaceBaseDatosRegistro interfaceRegistro;
   private RegistroUsuario registroUsuario;
   private InterfaceUsuario interfaceUsuario;
        
   public ManejadorRegistroUsuario() {
        pantallaRegistroUsuario = new PantallaRegistroUsuario();
        interfaceUsuario = new InterfaceUsuario(this,pantallaRegistroUsuario);
        interfaceRegistro = new InterfaceBaseDatosRegistro();
        pantallaRegistroUsuario.setInterfaceUsuario(interfaceUsuario);
        interfaceUsuario.desplegarPantalla();
   }
   public void manejarEvento(String str) {
	if (str.equals("Registrar"))
		manejarEventoRegistrar();
 	else if (str.equals("Consultar"))
		manejarEventoConsultar();
	else if (str.equals("Actualizar"))
		manejarEventoActualizar();
 	else if (str.equals("Eliminar"))
		manejarEventoEliminar();
 	else if (str.equals("Limpiar"))
		manejarEventoLimpiar();
 	else
		manejarEventoSalir();
    }
    private void manejarEventoRegistrar() {
         if (registroUsuario == null)
              registroUsuario = new RegistroUsuario();
         interfaceUsuario.leerElementos(registroUsuario);
         interfaceRegistro.crearRegistro(registroUsuario);
    }
    private void manejarEventoConsultar() {
         if (registroUsuario == null)
              registroUsuario = new RegistroUsuario();
         interfaceUsuario.leerElementos(registroUsuario);
         String log = registroUsuario.leerValor("login");
         interfaceRegistro.obtenerRegistro(registroUsuario,log);
         interfaceUsuario.escribirElementos(registroUsuario);
    }
    private void manejarEventoActualizar() {
         if (registroUsuario == null)
              registroUsuario = new RegistroUsuario();
         interfaceUsuario.leerElementos(registroUsuario);
         interfaceRegistro.actualizarRegistro(registroUsuario);
    }
    private void manejarEventoLimpiar() {
         registroUsuario = new RegistroUsuario();
         pantallaRegistroUsuario.escribirElementos(registroUsuario);
    }
    private void manejarEventoEliminar() {
	 if (registroUsuario == null)
		System.out.println("Registro Invalido");
	 else
                interfaceRegistro.eliminarRegistro(registroUsuario);
         registroUsuario = new RegistroUsuario();
         interfaceUsuario.escribirElementos(registroUsuario);
    }
    private void manejarEventoSalir() {
         System.exit(0);
    }
    public static void main(String[] args) {
         ManejadorRegistroUsuario m = new ManejadorRegistroUsuario();
    }
}
