package registrojdbc;

import java.util.*;
import java.awt.*;
import java.awt.event.*;

abstract class Pantalla {

  protected Vector<Panel> paneles;
  protected Vector<Button> botones;
  protected Vector<TextField> textos;
  protected Panel panel;
  protected Button boton;
  protected TextField texto;
  protected InterfaceUsuario interfaceUsuario;

  protected Pantalla() {
    inicializarPantalla();
    crearPantalla();
  }
  protected void setInterfaceUsuario(InterfaceUsuario iu){
     interfaceUsuario = iu; 
  }
  protected void desplegarPantalla() {
    System.out.println("Desplegando: "+ this);
    int ps = paneles.size();
    interfaceUsuario.setLayout(new GridLayout(ps,1));
    for (int i = 0; i < ps; i++)
      interfaceUsuario.add((Panel)paneles.elementAt(i));
    int bs = botones.size();
    for (int i = 0; i < bs; i++)
      if ((boton = (Button)botones.elementAt(i)) != null)
        boton.addActionListener(interfaceUsuario);
  }
  // Otras Responsabilidades Publicas
  protected void inicializarPantalla() {
    paneles = new Vector<Panel>();
    botones = new Vector<Button>();
    textos = new Vector<TextField>();
  }
  protected abstract void crearPantalla();
  
  public String leerTexto(String name0) {
    String name = null, str = null;
    for (int j = 0; name0.equals(name) == false && j < textos.size(); j++) {
          name = ((Component) textos.elementAt(j)).getName();
          if (name0.equals(name) == true)
            str = ((TextField) textos.elementAt(j)).getText();
    }
    System.out.println(name+": "+str);

    return str;
  }
  public void leerElementos(Datos datos) {
    String name0,str,name;
    for (int i = 0; i < datos.numeroAtributos(); i++) {
      name0 = (String)datos.leerNombre(i);
      str = null;
      name = null;
      for (int j = 0; name0.equals(name) == false && j < textos.size(); j++) {
          name = ((Component) textos.elementAt(j)).getName();
          if (name0.equals(name) == true)  {
            str = ((TextField) textos.elementAt(j)).getText();
            datos.escribirValor(i,str);
          }
      }
      System.out.println(name+": "+str);
    }
  }
  public void escribirElementos(Datos datos) {
    String name0,str,name;
    for (int i = 0; i < datos.numeroAtributos(); i++) {
      name0 = (String)datos.leerNombre(i);
      str = (String)datos.leerValor(i);
      name = null;
      for (int j = 0; name0.equals(name) == false && j < textos.size(); j++) {
          name = ((Component) textos.elementAt(j)).getName();
          if (name0.equals(name) == true) {
            ((TextField) textos.elementAt(j)).setText(str);
             System.out.println(name0+": "+str);
          }
      }
    }
  }
}
